	.module monitor2.c
	.area text
_main::
monitor2.112::	
; /*******************************************************************************
;  *                                                                             *
;  *                          Written by Jack Crotty                             *
;  *                           Tullahoma, Tennessee                              *
;  *                              Copyright 2001                                 *
;  *                            All Rights Reserved                              *
;  *                           Updated 29 April 2001                             *
;  *                            Jack___46@Yahoo.com                              *
;  *                                 Monitor2.c                                  *
;  *                                                                             *
;  *******************************************************************************/
; #include <hc12.h>
; #include <stdio.h>
; 
; #define ABOVE_FLASH     0xC000      /* Used to compare Address for Flash loads */
; #define BLINKRATE       2           /* LED Blink Rate for S-Record operations  */
; #define BS              8           /* ASCII backspace                         */
; #define CHARSPERROW     16          /* Number of characters per line (Dump cmd)*/
; #define COMPLETED       3           /* Signals process is complete             */
; #define CR              0xD         /* ASCII Carrage return                    */
; #define DECREMENT       0x12        /* Flag to indicate user wants to dec addr */
; #define ESCAPE          0x1B        /* ASCII for escape key (terminates cmds)  */
; #define FALSE           0           /* Boolean indication for NOT True         */
; #define FLASH           0x8000      /* Start of Flash memory in system         */
; #define INCREMENT       0x11        /* Flag to indicate user wants to inc addr */
; #define LAST_PPAGE      0x1F        /* Last Program Flash page (set 128K = 07) *
;                                      * redefine and compile, or change value   *
;                                      * in RAM location (Last_PPAGE--adr in LST */
; #define LED             0x40        /* Bit definition for LED on Technological *
;                                      *          Arts DX 812 board              */
; #define LF              0xA         /* ASCII Line feed                         */
; #define PERIOD          '.'         /* ASCII for period (used as delimiter)    */
; #define RE              0x20        /* Receiver ready bit in SCI register      */
; #define ROWSPERSCREEN   24          /* Number of rows per screen dump          */
; #define SPACE           0x20        /* ASCII space                             */
; #define SUCCESS         2           /* Signals success for process             */
; #define TRANSCOMPLETE   0x40        /* Transmit complete SCI Status register.  */
; #define TE              0x80        /* Transmitter ready bit in SCI register   */
; #define TERMINATED      0x10        /* Process terminated with Escape or CR    */
; #define TRUE            1           /* Flag to value to indicate success truth */
; #define UPPER_REG       0x1FF       /* Last memory address for registers       *
; 
;  ***************************************************************************
;  *                                                                         *
;  ************************* Global variables ********************************
;  *                                                                         *
;  ***************************************************************************/
; 
; unsigned char  *Address,    /* Holds the address of character entered for  *
;                              * S-Record, memory examine, and fill commands */
;                 Adrhi,      /* Holds upper half for the above address      */
;                 Adrlo;      /* Holds lower half for the above address      */
; char            Banking,    /* When True Records contain and set PPAGE     */
;                 CheckSum,   /* CheckSum for S-Record operations            */
;                 Count,      /* Holds record count for S-Record routines    */
;                 Curpage,    /* Contains Program page for Flash operations  */
;                 Data,       /* Data being read and passed to Flash program */
;                 Error,      /* Error indication for operation              */
;                 Last_PPAGE, /* Last_PPAGE contains the last allowed page   */
;                 MSBadr;     /* Most significant nibble for Flash address   */
; 
; /***************************************************************************
;  *                                                                         *
;  ************************** Function Prototypes ****************************
;  *                                                                         *
;  ***************************************************************************/
; 
;   void Back             (char);
;   char BuildAddress     (char);
;   char BuildChar        (char);
;   void Clr_Screen       (void);
;   void CRLF             (void);
;   void Dump             (void);
;   void DisplayCommands  (void);
;   void Display_New_Addr (char);
;   void Display_New_Char (char);
;   void EraseFlash       (void);
;   void Examine          (void);
;   void Execute          (void);
;   void Fill             (void);
;   void GetAddress       (void);
;   char GetByte          (void);
;   char GetChar          (void);
;   char GetSRecord       (void);
;   void Initialize       (void);
;   void LED_Off          (void);
;   void LED_On           (void);
;   void Load_SRecord     (void);
;   void PutByte          (unsigned char);
;   void PutChar          (char);
;   void PutString        (char *);
;   void PutWord          (unsigned int);
;   void Process_Cmd      (void);
;   void Program_Flash    (void);
;   void Reset            (void);
;   void Verify_SRecord   (void);
;   void WriteFlash       (void);
; 
; /***************************************************************************
;  *                                                                         *
;  ***************************** Start Main Program **************************
;  *                                                                         *
;  ***************************************************************************/
; 
; main(void)
; {
;     /* Basic Monitor Program for Technological Arts *
;      * Motorola 68HC812A4 based processor system.   *
;      * Program resides in EEPROM, and is, therefore *
;      * limited to 4K (including Vectors and Loader) */
; 
;     Initialize();               /* Initialize System state  */
	jsr _Initialize
monitor2.113::	
;     Process_Cmd();			    /* Process user commands    *
	jsr _Process_Cmd
monitor2.115::	
;                                  * until terminated by user */
;     return(0);
	ldd #0
L2:
	rts
;          ?temp -> -4,x
;           temp -> -1,x
_Load_SRecord::
	pshx
	tfr s,x
	leas -7,sp
monitor2.134::	
; }
; 
; /***************************************************************************
;  *                                                                         *
;  ***************************** End Main Program ****************************
;  *                                                                         *
;  ***************************************************************************/
; 
; /*******************************************
;  *                                         *
;  * Function to Load S-Records into memory. *
;  * Uses GetSRecord                         *
;  *                                         *
;  *******************************************/
; void Load_SRecord (void)
; {
;     char temp;
; 
;     Error = FALSE;
	movb #0,_Error
	bra L5
L7:
monitor2.148::	
	jsr _GetByte
	stab -1,x
monitor2.149::	
	movw _Address,-4,x
	ldd -4,x
	addd #1
	std _Address
	ldab -1,x
	tfr b,d
	ldy -4,x
	stab 0,y
monitor2.150::	
	ldab _CheckSum
	addb -1,x
	stab _CheckSum
monitor2.151::	
	dec _Count
monitor2.152::	
L8:
monitor2.145::	
; 
;     while (( GetSRecord()) != COMPLETED )
;     {
;         /************************************************
;          *                                              *
;          * GetSRecord sets Address and Count (also      *
;          * updates CheckSum) for this record, so        *
;          * simply load the record based on these values *
;          *                                              *
;          ************************************************/
;         while (Count > 1)
	ldab _Count
	cmpb #1
	bgt L7
monitor2.160::	
;         {
;             /* Store the data into memory locations     */
;             temp       = GetByte();
;             *Address++ = temp;
;             CheckSum  += temp;
;             Count--;
;         }
;         /***********************************************
;          *                                             *
;          * Checksum for this record remains, get it,   *
;          * and compare it to the value calculated.     *
;          *                                             *
;          ***********************************************/
; 
;         if (GetByte() != ~CheckSum)
	jsr _GetByte
	std -6,x
	ldab _CheckSum
	comb
	stab -7,x
	ldab -5,x
	cmpb -7,x
	beq L10
monitor2.162::	
;             /* Error occurred in loading this record   */
;             Error = TRUE;
	movb #1,_Error
L10:
monitor2.163::	
L5:
monitor2.136::	
	jsr _GetSRecord
	cmpb #3
	bne L8
monitor2.164::	
;     }/* Load has completed */
; }
L3:
	tfr x,s
	pulx
	rts
;           done -> -1,x
_Program_Flash::
	pshx
	tfr s,x
	leas -5,sp
monitor2.174::	
; 
; /*********************************************
;  *                                           *
;  * Function to Program S-Records into Flash. *
;  * Uses GetSRecord                           *
;  *                                           *
;  *********************************************/
; void Program_Flash (void)
; {
;     char done = FALSE;
	movb #0,-1,x
monitor2.176::	
; 
;     Error = FALSE;
	movb #0,_Error
	bra L14
L13:
monitor2.187::	
; 
;     while (GetSRecord() != COMPLETED )
;     {
;         /************************************************
;          *                                              *
;          * GetSRecord sets Address and Count (also      *
;          * updates CheckSum) for this record, so        *
;          * simply load the record based on these values *
;          *                                              *
;          ************************************************/
;         if (Address >= (unsigned char *)ABOVE_FLASH)
	ldd _Address
	cpd #0xc000
	blo L19
monitor2.193::	
;         {
;             /* S1 Record is attempting to write to Last Flash page.  *
;              * S2 would set PPAGE directly and leave address between *
;              * 8000 and BFFF.  So limit address to 8000 - BFFF, and  *
;              * set LAST_PPAGE (512 K = 1F, 128 K would be 7).        */
;             Address = (unsigned char *)((int)Address & (ABOVE_FLASH-1));
	ldd _Address
	anda #191
	andb #255
	std _Address
monitor2.194::	
;             PPAGE = Last_PPAGE;     /* Set PPAGE (Last_PPAGE is RAM */
	ldab _Last_PPAGE
	tfr b,d
	stab 0x35
monitor2.195::	
;         }
	bra L19
L18:
monitor2.199::	
;         while (Count > 1)
;         {
;             /* Get data into memory locations     */
;             Data = GetByte();
	jsr _GetByte
	stab _Data
monitor2.200::	
;             if (Address >= (unsigned char *)FLASH)
	ldd _Address
	cpd #0x8000
	blo L21
monitor2.201::	
;                 WriteFlash();
	jsr _WriteFlash
	bra L22
L21:
monitor2.203::	
;             else
;                 *Address = Data;
	ldab _Data
	tfr b,d
	ldy _Address
	stab 0,y
L22:
monitor2.205::	
	ldd _Address
	addd #1
	std _Address
monitor2.206::	
	ldab _CheckSum
	addb _Data
	stab _CheckSum
monitor2.207::	
	dec _Count
monitor2.208::	
L19:
monitor2.196::	
	ldab _Count
	cmpb #1
	bgt L18
monitor2.215::	
; 
;             Address++;
;             CheckSum  += Data;
;             Count--;
;         }
;         /***********************************************
;          *                                             *
;          * Checksum for this record remains, get it,   *
;          * and compare it to the value calculated.     *
;          *                                             *
;          ***********************************************/
;         if (GetByte() != ~CheckSum)
	jsr _GetByte
	std -4,x
	ldab _CheckSum
	comb
	stab -5,x
	ldab -3,x
	cmpb -5,x
	beq L23
monitor2.217::	
;             /* Error occurred in loading this record   */
;             Error = TRUE;
	movb #1,_Error
L23:
monitor2.218::	
L14:
monitor2.178::	
	jsr _GetSRecord
	cmpb #3
	lbne L13
monitor2.219::	
;     }/* Load has completed */
; }
L12:
	tfr x,s
	pulx
	rts
;           temp -> -1,x
_Verify_SRecord::
	pshx
	tfr s,x
	leas -2,sp
monitor2.231::	
; 
; /*******************************************
;  *                                         *
;  * Function to Verify S-Records to Memory. *
;  * Uses GetSRecord                         *
;  *                                         *
;  *******************************************/
; void Verify_SRecord (void)
; {
;     char temp;
; 
;     Error  = FALSE;
	movb #0,_Error
monitor2.232::	
;     PORTT &= ~LED;
	bclr 0xae,#0x40
	bra L27
L29:
monitor2.245::	
; 
;     while (GetSRecord() != COMPLETED )
;     {
;         /************************************************
;          *                                              *
;          * GetSRecord sets Address and Count (also      *
;          * updates CheckSum) for this record, so simply *
;          * compare the record to values in memory.      *
;          *                                              *
;          ************************************************/
;         while (Count > 1)
;         {
;             temp = GetByte();
	jsr _GetByte
	stab -1,x
monitor2.247::	
; 
;             if ((unsigned int) Address <= UPPER_REG)
	ldd _Address
	cpd #511
	bhi L32
monitor2.250::	
; 
;                /* Write value to register */
;                *Address = temp;
	ldab -1,x
	tfr b,d
	ldy _Address
	stab 0,y
	bra L33
L32:
monitor2.253::	
;             else
;                 /* Not a register address, so compare memory */
;                 if(*Address != temp)
	ldy _Address
	ldab 0,y
	cmpb -1,x
	beq L34
monitor2.254::	
;                     Error = TRUE;
	movb #1,_Error
L34:
L33:
monitor2.256::	
	ldd _Address
	addd #1
	std _Address
monitor2.257::	
	ldab _CheckSum
	addb -1,x
	stab _CheckSum
monitor2.258::	
	dec _Count
monitor2.259::	
L30:
monitor2.243::	
	ldab _Count
	cmpb #1
	bgt L29
monitor2.266::	
	jsr _GetByte
	stab -1,x
monitor2.267::	
L27:
monitor2.234::	
	jsr _GetSRecord
	cmpb #3
	bne L30
monitor2.268::	
; 
;             Address++;
;             CheckSum  += temp;
;             Count--;
;         }
;         /***********************************************
;          *                                             *
;          * Checksum for this record remains, get it,   *
;          * and ignore it (memory contents matched.     *
;          *                                             *
;          ***********************************************/
;         temp = GetByte();
;     }/* Verify is complete */
; }
L25:
	tfr x,s
	pulx
	rts
	.area data
L37:
	.blkb 1
	.area idata
	.byte 0
	.area text
;          ?temp -> -8,x
;          ?temp -> -6,x
;          ?temp -> -3,x
;       received -> -2,x
;         inchar -> -1,x
_GetSRecord::
	pshx
	tfr s,x
	leas -8,sp
monitor2.301::	
; 
; /*********************************************************************
;  *                                                                   *
;  * Function:                                                         *
;  * GetSRecord(void)                                                  *
;  *                                                                   *
;  * Receives Motorola 'S' formated memory load files.                 *
;  * S0 record is file information, and are ignored by this function   *
;  * S1 record has address followed by the byte count for this record  *
;  * S2 record has 24 bit address (compared to 16 for S1), byte count  *
;  * S9 record indicates the file is terminating                       *
;  *                                                                   *
;  * if S1 is received                                                 *
;  * Function returns 'SUCCESS',                                       *
;  * sets Address, sets Count, and                                     *
;  * calculates CheckSum for Count and Address                         *
;  *                                                                   *
;  * if S2 is received                                                 *
;  * Function sets PPAGE, returns 'SUCCESS',                           *
;  * sets Address, sets Count, and                                     *
;  * calculates CheckSum for Count and Address                         *
;  *                                                                   *
;  * if S9 is received                                                 *
;  * Function returns 'COMPLETE'                                       *
;  * after getting count and waiting for the number of characters      *
;  *                                                                   *
;  * uses GetChar(), GetByte(), GetAddress()                           *
;  *********************************************************************/
; char GetSRecord (void)
; {
;     static char count    = 0;
;            char inchar,
;                 received = FALSE;
	movb #0,-2,x
	lbra L39
L41:
monitor2.306::	
; 
;     while (!received)
;     {
;         /* Wait for 'S' (UPPERCASE) to be received. */
;         while (GetChar() != 'S');
L42:
	jsr _GetChar
	cmpb #83
	bne L41
monitor2.313::	
;         /******************************************
;          *                                        *
;          * 'S' received, Get input, and ignore if *
;          * it is not a 1,2 or 9 (S1-S2-S9 record) *
;          *                                        *
;          ******************************************/
;         inchar = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.315::	
; 
;         if (++count > BLINKRATE)
	ldab L37
	addb #1
	stab -3,x
	movb -3,x,L37
	ldab -3,x
	cmpb #2
	ble L44
monitor2.317::	
;         {
;             PORTT = PORTT ^ LED;
	; vol
	ldab 0xae
	clra
	eora #0
	eorb #64
	stab 0xae
monitor2.318::	
;             count = 0;
	movb #0,L37
monitor2.319::	
;         }
L44:
monitor2.321::	
; 
;         switch (inchar)
	ldab -1,x
	tfr b,d
	std -6,x
	cpd #49
	beq L49
	ldd -6,x
	cpd #50
	beq L56
	ldd -6,x
	cpd #49
	lblt L46
L63:
	ldd -6,x
	cpd #57
	lbeq L59
	lbra L46
L49:
monitor2.330::	
;         {
;             case '1':
;                 /************************************
;                  *                                  *
;                  * Get the Count, Address, and      *
;                  * indicate Success for this record *
;                  *                                  *
;                  ************************************/
;                 Count    = GetByte();
	jsr _GetByte
	stab _Count
monitor2.331::	
;                 CheckSum = Count;
	movb _Count,_CheckSum
monitor2.338::	
; 
;                 /*******************************
;                  *                             *
;                  * Update Address and CheckSum *
;                  *                             *
;                  *******************************/
;                 GetAddress();
	jsr _GetAddress
monitor2.340::	
; 
;                 if (!Banking)
	tst _Banking
	bne L50
monitor2.344::	
;                 {
;                     /* Non banking mode need to check if *
;                      * operation is in second last 16K.  */
;                     if ((unsigned int) Address <= (ABOVE_FLASH-1) &&
	ldd _Address
	std -8,x
	cpd #0xbfff
	bhi L52
	ldd -8,x
	cpd #0x8000
	blo L52
monitor2.347::	
;                        ((unsigned int) Address >=  FLASH))
;                         /* record writing to second last 16 K */
;                         PPAGE = (Last_PPAGE - 1);
	ldab _Last_PPAGE
	tfr b,d
	subd #1
	stab 0x35
	bra L53
L52:
monitor2.349::	
;                     else
;                         if ((unsigned int) Address >= ABOVE_FLASH)
	ldd _Address
	cpd #0xc000
	blo L54
monitor2.351::	
;                             /* record is writing to last 16 K */
;                             PPAGE = (Last_PPAGE);
	ldab _Last_PPAGE
	tfr b,d
	stab 0x35
L54:
L53:
monitor2.352::	
;                 }
L50:
monitor2.353::	
;                 Count    = Count - 2;
	ldab _Count
	subb #2
	stab _Count
monitor2.354::	
;                 received = SUCCESS;
	movb #2,-2,x
monitor2.355::	
;                 break;
	lbra L47
L56:
monitor2.364::	
; 
;             case '2':
;                 /**************************************
;                  *                                    *
;                  * Get the Count, 24 bit Address, and *
;                  * indicate Success for this record.  *
;                  *                                    *
;                  **************************************/
;                 Count    = GetByte();
	jsr _GetByte
	stab _Count
monitor2.365::	
;                 CheckSum = Count;
	movb _Count,_CheckSum
monitor2.372::	
; 
;                 /*******************************
;                  *                             *
;                  * Update Address and CheckSum *
;                  *                             *
;                  *******************************/
;                 MSBadr    = GetByte();
	jsr _GetByte
	stab _MSBadr
monitor2.373::	
;                 CheckSum += MSBadr;
	ldab _CheckSum
	addb _MSBadr
	stab _CheckSum
monitor2.375::	
; 
;                 GetAddress();
	jsr _GetAddress
monitor2.376::	
;                 PPAGE = (MSBadr<<2 + Adrhi>>6);
	ldy #6
	ldab _Adrhi
	clra
	addd #2
	pshy ; spill
	xgdy
	ldab _MSBadr
	tfr b,d
	cpy #0
	beq X0
X1:
	lsld
	dbne y,X1
X0:
	puly ; reload
	cpy #0
	beq X2
X3:
	asra
	rorb
	dbne y,X3
X2:
	stab 0x35
monitor2.378::	
; 
;                 if (PPAGE > Last_PPAGE)
	; vol
	ldab 0x35
	cmpb _Last_PPAGE
	bls L57
monitor2.379::	
;                     Error = TRUE;
	movb #1,_Error
L57:
monitor2.381::	
; 
; 	            Address = (unsigned char *)((int)Address & (ABOVE_FLASH-1));
	ldd _Address
	anda #191
	andb #255
	std _Address
monitor2.384::	
; 
; 
;                 Count    = Count - 3;
	ldab _Count
	subb #3
	stab _Count
monitor2.385::	
;                 received = SUCCESS;
	movb #2,-2,x
monitor2.386::	
;                 break;
	bra L47
L59:
monitor2.399::	
; 
;             case '9':
;                 /********************************************
;                  *                                          *
;                  * End of record has been received. Need to *
;                  * get count, and the remaining characters. *
;                  * ie S9030000FC (checksum for S9 record is *
;                  * ignored--if there are no errors to this  *
;                  * point, information loaded correctly.     *
;                  *                                          *
;                  ********************************************/
; 
;                 Count = GetByte();
	jsr _GetByte
	stab _Count
	bra L61
L60:
monitor2.403::	
	jsr _GetByte
	stab -1,x
monitor2.404::	
	dec _Count
monitor2.405::	
L61:
monitor2.401::	
; 
;                 while (Count)
	tst _Count
	bne L60
monitor2.406::	
;                 {
;                     inchar = GetByte();
;                     Count--;
;                 }
;                 received = COMPLETED;
	movb #3,-2,x
monitor2.407::	
;                 inchar   = GetChar();   /* Imagecraft Compiler, and Motorola Assembler *
	jsr _GetChar
	stab -1,x
monitor2.414::	
;                                          * both send a carriage return after the end   *
;                                          * of the Record -- May need to be removed for *
;                                          * records generated from other sources....... *
;                                          * if removed it will result in a double enter *
;                                          * command line from monitor would lockup if   *
;                                          * program does not send terminating character */
;                 break;
L46:
L47:
monitor2.416::	
L39:
monitor2.303::	
	tst -2,x
	lbeq L42
monitor2.424::	
;         } /* end switch */
;     } /* end while (!done) */
; 
;     /************************************************************
;      *                                                          *
;      * When program comes here, while has completed, therefore, *
;      * Record was either S1 or S9 so return indication          *
;      *                                                          *
;      ************************************************************/
;     return (received);
	ldab -2,x
	tfr b,d
L36:
	tfr x,s
	pulx
	rts
;          ?temp -> -3,x
;         templo -> -2,x
;         temphi -> -1,x
_GetByte::
	pshx
	tfr s,x
	leas -4,sp
monitor2.439::	
; }
; 
; /****************************************************
;  *                                                  *
;  * Function to Get 2 ASCII characters from SCI port *
;  * using GetChar.  Assumes characters are 0 - 9 or  *
;  * A - F. Returns characters combined as a byte     *
;  *                                                  *
;  ****************************************************/
; char GetByte (void)
; {
;     char temphi,
;          templo;
; 
;     temphi = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.441::	
; 
;     if(temphi > '9')
	ldab -1,x
	cmpb #57
	ble L65
monitor2.444::	
;     /* Character is an alpha *
;      * correct the nibble.   */
;         temphi += 9;        /* A would be 41 hex (1 when it's upper nibble */
	ldab -1,x
	addb #9
	stab -1,x
L65:
monitor2.446::	
; 
;     temphi = temphi << 4;   /* Make input character the upper nibble. */
	ldab -1,x
	lslb
	lslb
	lslb
	lslb
	stab -1,x
monitor2.447::	
;     templo = GetChar();     /* Get least significant nibble adjust    *
	jsr _GetChar
	stab -2,x
monitor2.450::	
;                              * it's value, and strip off upper nibble */
; 
;     if ( templo > '9')
	ldab -2,x
	cmpb #57
	ble L67
monitor2.451::	
;         templo += 9;
	ldab -2,x
	addb #9
	stab -2,x
L67:
monitor2.453::	
; 
;     templo &= 0x0F;
	bclr -2,x,#0xf0
monitor2.457::	
; 
;     /* Assemble nibbles, and return *
;      * the 'new' byte to the caller */
;     return (temphi |= templo);
	ldab -1,x
	orab -2,x
	stab -3,x
	movb -3,x,-1,x
	ldab -3,x
	tfr b,d
L64:
	tfr x,s
	pulx
	rts
_GetAddress::
	pshx
	tfr s,x
	leas -2,sp
monitor2.471::	
; }
; 
; /********************************************************
;  *                                                      *
;  * Function to Get 4 ASCII characters from SCI port     *
;  * using GetByte.  Places entered nibbles of address    *
;  * in Global characters Adrhi and Adrlo before placing  *
;  * them into Global character pointer (Address). Also   *
;  * updates the checksum for received address lo and hi. *
;  *                                                      *
;  ********************************************************/
; void GetAddress(void)
; {
;     Adrhi     = GetByte();
	jsr _GetByte
	tfr b,d
	stab _Adrhi
monitor2.472::	
;     Adrlo     = GetByte();
	jsr _GetByte
	tfr b,d
	stab _Adrlo
monitor2.473::	
;     CheckSum += (Adrhi) | (Adrlo);
	ldab _Adrhi
	orab _Adrlo
	stab -1,x
	ldab _CheckSum
	addb -1,x
	stab _CheckSum
monitor2.474::	
;     Address   = (unsigned char *) (Adrhi * 256 | Adrlo );
	ldab _Adrlo
	clra
	std -2,x
	ldab _Adrhi
	clra
	tba
	clrb
	ora -2,x
	orb -1,x
	std _Address
monitor2.475::	
; }
L69:
	tfr x,s
	pulx
	rts
;          ?temp -> -12,x
;          ?temp -> -10,x
;          ?temp -> -8,x
;          ?temp -> -6,x
;          ?temp -> -4,x
;           done -> -2,x
;          input -> -1,x
;        message -> 3,x
_BuildAddress::
	pshd
	pshx
	tfr s,x
	leas -14,sp
monitor2.489::	
; 
; /********************************************************
;  *                                                      *
;  * Function to Build address from input on SCI port     *
;  * using GetChar.  Address is built a nibble at a time  *
;  * input is terminated with a space or enter.  Address  *
;  * initially is set to zero.  Function uses Global      *
;  * characters Adrhi and Adrlo for build and places the  *
;  * final result in Global pointer (Address).            *
;  *                                                      *
;  ********************************************************/
; char BuildAddress(char message)
; {
;     char done = FALSE;
	movb #0,-2,x
monitor2.492::	
;     char input;
; 
;     if(message)
	tst 3,x
	beq L71
monitor2.494::	
;     {
;         CRLF();
	jsr _CRLF
monitor2.495::	
;         PutString (" Enter Address:  ");
	ldd #L73
	jsr _PutString
monitor2.496::	
;     }
L71:
monitor2.499::	
;     /* Make default what was left in address *
;      * variables (Adrhi and Adrlo )...       */
;     PutByte(Adrhi);
	ldab _Adrhi
	clra
	jsr _PutByte
monitor2.500::	
;     PutByte(Adrlo);
	ldab _Adrlo
	clra
	jsr _PutByte
	lbra L75
L74:
monitor2.505::	
; 
;     while(!done)
;     {
;         /* Get next character from user */
;         input = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.506::	
;         if ((input >= '0')  &&
	ldab -1,x
	tfr b,d
	std -4,x
	cpd #48
	blt L77
	ldd -4,x
	cpd #57
	bgt L77
monitor2.510::	
;             (input <= '9'))
;         {
;             /* User entered a digit */
;             input &= 0xF;
	bclr -1,x,#0xf0
monitor2.511::	
;             Display_New_Addr(input);
	ldab -1,x
	tfr b,d
	jsr _Display_New_Addr
monitor2.512::	
;         }
	bra L78
L77:
monitor2.514::	
;         else
;             if ((input == SPACE) ||
	ldab -1,x
	tfr b,d
	std -6,x
	cpd #32
	beq L81
	ldd -6,x
	cpd #13
	bne L79
L81:
monitor2.517::	
;                 (input == CR))
;                 /* User completed input */
;                 done = TRUE;
	movb #1,-2,x
	bra L80
L79:
monitor2.520::	
;             else
;             {
;                 if ((input >= 'A')  &&
	ldab -1,x
	tfr b,d
	std -8,x
	cpd #65
	blt L85
	ldd -8,x
	cpd #70
	ble L84
L85:
	ldab -1,x
	tfr b,d
	std -10,x
	cpd #97
	blt L82
	ldd -10,x
	cpd #102
	bgt L82
L84:
monitor2.527::	
;                     (input <= 'F')
;                            ||
;                     (input >= 'a')  &&
;                     (input <= 'f'))
;                 {
;                     /* Correct hexidecimal digit */
;                     input = (input & 0x7) + 9;
	ldab -1,x
	andb #7
	addb #9
	stab -1,x
monitor2.528::	
;                     Display_New_Addr(input);
	ldab -1,x
	tfr b,d
	jsr _Display_New_Addr
monitor2.529::	
;                 }
	bra L83
L82:
monitor2.531::	
;                 else
;                     if ((input == ESCAPE) ||
	ldab -1,x
	tfr b,d
	std -12,x
	cpd #27
	beq L88
	ldd -12,x
	cpd #46
	bne L86
L88:
monitor2.534::	
;                         (input == PERIOD))
;                         /* User terminated input */
;                         return (TERMINATED);
	ldd #16
	bra L70
L86:
L83:
monitor2.535::	
;             }
L80:
L78:
monitor2.536::	
L75:
monitor2.502::	
	tst -2,x
	lbeq L74
monitor2.537::	
;     }
;     Address = (unsigned char *) (Adrhi * 256 + Adrlo );
	ldab _Adrlo
	clra
	std -14,x
	ldab _Adrhi
	clra
	tba
	clrb
	addd -14,x
	std _Address
monitor2.538::	
;     return (COMPLETED);
	ldd #3
L70:
	tfr x,s
	pulx
	leas 2,sp
	rts
;          ?temp -> -12,x
;          ?temp -> -10,x
;          ?temp -> -8,x
;          ?temp -> -6,x
;          ?temp -> -4,x
;           done -> -2,x
;          input -> -1,x
;          value -> 3,x
_BuildChar::
	pshd
	pshx
	tfr s,x
	leas -13,sp
monitor2.552::	
; }
; 
; /**********************************************************
;  *                                                        *
;  * Function to Build character from input on SCI port     *
;  * using GetChar.  Character is built a nibble at a time  *
;  * input is terminated with a space.  Character initially *
;  * is set to zero.  Function uses Global character Adrlo  *
;  * and places the final result in Global variable Adrlo.  *
;  *                                                        *
;  **********************************************************/
; char BuildChar(char value)
; {
;     char done = FALSE;
	movb #0,-2,x
monitor2.555::	
;     char input;
; 
;     PutByte(value);     /* Display default character on screen */
	ldab 3,x
	tfr b,d
	clra
	jsr _PutByte
	lbra L91
L90:
monitor2.560::	
; 
;     while(!done)
;     {
;         /* Get next character from user */
;         input = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.561::	
;         if ((input >= '0') &&
	ldab -1,x
	tfr b,d
	std -4,x
	cpd #48
	blt L93
	ldd -4,x
	cpd #57
	bgt L93
monitor2.565::	
;             (input <= '9'))
;         {
;             /* User entered a digit */
;             value = (value * 16) | (input & 0x0F);
	ldab -1,x
	andb #15
	stab -13,x
	ldab 3,x
	lslb
	lslb
	lslb
	lslb
	orab -13,x
	stab 3,x
monitor2.566::	
;             Display_New_Char(value);
	ldab 3,x
	tfr b,d
	jsr _Display_New_Char
monitor2.567::	
;         }
	lbra L94
L93:
monitor2.569::	
;         else
;             if ((input == SPACE) ||
	ldab -1,x
	tfr b,d
	std -6,x
	cpd #32
	beq L97
	ldd -6,x
	cpd #13
	bne L95
L97:
monitor2.572::	
;                 (input == CR))
;                 /* User completed input */
;                 done = TRUE;
	movb #1,-2,x
	bra L96
L95:
monitor2.575::	
;             else
;             {
;                 if ((input >= 'A')  &&
	ldab -1,x
	tfr b,d
	std -8,x
	cpd #65
	blt L101
	ldd -8,x
	cpd #70
	ble L100
L101:
	ldab -1,x
	tfr b,d
	std -10,x
	cpd #97
	blt L98
	ldd -10,x
	cpd #102
	bgt L98
L100:
monitor2.582::	
;                     (input <= 'F')
;                            ||
;                     (input >= 'a')  &&
;                     (input <= 'f'))
;                 {
;                     /* Correct hexidecimal digit */
;                     value = ((value * 16) | ((input & 0x7) + 9));
	ldab -1,x
	andb #7
	addb #9
	stab -13,x
	ldab 3,x
	lslb
	lslb
	lslb
	lslb
	orab -13,x
	stab 3,x
monitor2.583::	
;                     Display_New_Char(value);
	ldab 3,x
	tfr b,d
	jsr _Display_New_Char
monitor2.584::	
;                 }
	bra L99
L98:
monitor2.586::	
;                 else
;                     if ((input == ESCAPE) ||
	ldab -1,x
	tfr b,d
	std -12,x
	cpd #27
	beq L104
	ldd -12,x
	cpd #46
	bne L102
L104:
monitor2.589::	
;                         (input == PERIOD))
;                         /* User terminated input */
;                         return (TERMINATED);
	ldd #16
	bra L89
L102:
monitor2.591::	
;                     else
;                         if (input == '+')
	ldab -1,x
	cmpb #43
	bne L105
monitor2.592::	
;                             return (INCREMENT);
	ldd #17
	bra L89
L105:
monitor2.594::	
;                         else
;                             if(input == '-')
	ldab -1,x
	cmpb #45
	bne L107
monitor2.595::	
;                                 return (DECREMENT);
	ldd #18
	bra L89
L107:
L99:
monitor2.596::	
;             }
L96:
L94:
monitor2.597::	
L91:
monitor2.557::	
	tst -2,x
	lbeq L90
monitor2.598::	
;     }
;     Adrlo = value;
	ldab 3,x
	tfr b,d
	stab _Adrlo
monitor2.599::	
;     return (COMPLETED);
	ldd #3
L89:
	tfr x,s
	pulx
	leas 2,sp
	rts
;          ?temp -> -4,x
;         status -> -1,x
_Examine::
	pshx
	tfr s,x
	leas -4,sp
monitor2.613::	
; }
; 
; /**********************************************************
;  *                                                        *
;  * Function to Examine memory contents for an address and *
;  * then allow the user to accept the contents, change the *
;  * contents, or go forward or backward in memory.         *
;  *                                                        *
;  **********************************************************/
; void Examine(void)
; {
;     char status;
; 
;     PutString("Examine Memory");
	ldd #L110
	jsr _PutString
monitor2.615::	
; 
;     if (BuildAddress(TRUE) != TERMINATED)
	ldd #1
	jsr _BuildAddress
	cmpb #16
	beq L111
monitor2.617::	
;     {
;         PutString (" ");
	ldd #L113
	jsr _PutString
	bra L115
L114:
monitor2.620::	
;         while (status != TERMINATED)
;         {
;             status = BuildChar (*Address);
	ldy _Address
	ldab 0,y
	tfr b,d
	jsr _BuildChar
	stab -1,x
monitor2.622::	
; 
;             if (status == COMPLETED)
	ldab -1,x
	cmpb #3
	bne L117
monitor2.623::	
;                 *Address++ = Adrlo;
	movw _Address,-4,x
	ldd -4,x
	addd #1
	std _Address
	ldab _Adrlo
	ldy -4,x
	stab 0,y
	bra L118
L117:
monitor2.625::	
;             else
;                 if (status == INCREMENT)
	ldab -1,x
	cmpb #17
	bne L119
monitor2.626::	
;                     Address++;
	ldd _Address
	addd #1
	std _Address
	bra L120
L119:
monitor2.628::	
;                 else
;                     if (status == DECREMENT)
	ldab -1,x
	cmpb #18
	bne L121
monitor2.629::	
;                         Address--;
	ldd _Address
	addd #-1
	std _Address
L121:
L120:
L118:
monitor2.631::	
; 
;             if (status != TERMINATED)
	ldab -1,x
	cmpb #16
	beq L123
monitor2.633::	
;             {
;                 CRLF();
	jsr _CRLF
monitor2.634::	
;                 PutString (" Enter Address:  ");
	ldd #L73
	jsr _PutString
monitor2.635::	
;                 PutWord((int)Address);
	ldd _Address
	jsr _PutWord
monitor2.636::	
;                 PutString(" ");
	ldd #L113
	jsr _PutString
monitor2.637::	
;             }
L123:
monitor2.638::	
L115:
monitor2.618::	
	ldab -1,x
	cmpb #16
	bne L114
monitor2.639::	
;         }
;     }
L111:
monitor2.640::	
; }
L109:
	tfr x,s
	pulx
	rts
_Execute::
monitor2.649::	
; /**********************************************************
;  *                                                        *
;  * Function to Execute a program from address entered     *
;  *                                                        *
;  **********************************************************/
; 
; void Execute (void)
; {
;     PutString(" Run Code");
	ldd #L126
	jsr _PutString
monitor2.650::	
;     if ( BuildAddress(TRUE) != TERMINATED )
	ldd #1
	jsr _BuildAddress
	cmpb #16
	beq L127
	LDY _Address
	JMP 0, Y
monitor2.655::	
;     {
;         /* User entered valid address */
;         asm ("LDY _Address");
;         asm ("JMP 0, Y");
;     }
L127:
monitor2.656::	
; }
L125:
	rts
;           temp -> -6,x
;           stop -> -4,x
;          start -> -2,x
_Fill::
	pshx
	tfr s,x
	leas -6,sp
monitor2.671::	
; 
; /**********************************************************
;  *                                                        *
;  * Function to Fill memory from a Start address to an End *
;  * address with a character. The addresses and character  *
;  * are input by the user on the SCI port                  *
;  *                                                        *
;  **********************************************************/
; void Fill(void)
; {
;     unsigned char *start,
;                   *stop;
;     int  temp;
; 
;     PutString("Fill Memory");
	ldd #L130
	jsr _PutString
monitor2.673::	
; 
;     if ( BuildAddress(TRUE) != TERMINATED )
	ldd #1
	jsr _BuildAddress
	cmpb #16
	beq L131
monitor2.676::	
;     {
;         /* User entered Start address */
;         start = Address;
	movw _Address,-2,x
monitor2.678::	
; 
;         if ( BuildAddress(TRUE) != TERMINATED )
	ldd #1
	jsr _BuildAddress
	cmpb #16
	beq L133
monitor2.681::	
;         {
;             /* User Entered End address */
;             stop = Address;
	movw _Address,-4,x
monitor2.682::	
;             CRLF();
	jsr _CRLF
monitor2.683::	
;             PutString(" Enter Char:     ");
	ldd #L135
	jsr _PutString
monitor2.684::	
;             if (BuildChar(0) != TERMINATED)
	ldd #0
	jsr _BuildChar
	cmpb #16
	beq L136
monitor2.687::	
;             {
;                 /* User entered Fill character */
;                 if (start <= stop)
	ldd -2,x
	cpd -4,x
	bhi L138
	bra L141
L140:
monitor2.691::	
;                     /* Addresses are in order fill memory */
;                     while (start <= stop)
;                     {
;                         *start = Adrlo;
	ldab _Adrlo
	ldy -2,x
	stab 0,y
monitor2.692::	
;                         if (*start != Adrlo)
	ldy -2,x
	ldab 0,y
	cmpb _Adrlo
	beq L143
monitor2.695::	
;                         {
;                             /* Value did NOT store properly */
;                             CRLF();
	jsr _CRLF
monitor2.696::	
;                             PutString(" ERROR at: ");
	ldd #L145
	jsr _PutString
monitor2.697::	
;                             temp = (int)start;
	ldd -2,x
	std -6,x
monitor2.698::	
;                             PutWord(temp);
	ldd -6,x
	jsr _PutWord
monitor2.699::	
;                             CRLF();
	jsr _CRLF
monitor2.700::	
;                             start = stop;
	movw -4,x,-2,x
monitor2.701::	
;                         }
L143:
monitor2.702::	
	ldd -2,x
	addd #1
	std -2,x
monitor2.703::	
L141:
monitor2.689::	
	ldd -2,x
	cpd -4,x
	bls L140
	bra L139
L138:
monitor2.706::	
;                         start++;
;                     }
;                 else
;                     /* Address out of range */
;                     puts("\n End < Start aborted!\n\n");
	ldd #L146
	jsr _puts
L139:
monitor2.707::	
;             }
L136:
monitor2.708::	
;         }
L133:
monitor2.709::	
;     }
L131:
monitor2.710::	
; }
L129:
	tfr x,s
	pulx
	rts
;          ?temp -> -14,x
;          ?temp -> -14,x
;          ?temp -> -14,x
;           done -> -12,x
;          input -> -11,x
;       dump_adr -> -10,x
;              i -> -7,x
;       data_ptr -> -6,x
;        adr_ptr -> -4,x
;              j -> -1,x
_Dump::
	pshx
	tfr s,x
	leas -16,sp
monitor2.721::	
; 
; /**********************************************************
;  *                                                        *
;  * Function to Dump memory contents to screen             *
;  *                                                        *
;  **********************************************************/
; void Dump (void)
; {
;     unsigned char *adr_ptr,
;                   *data_ptr,
;                    done = FALSE,
	clr -12,x
monitor2.727::	
;                    i,
;                    input,
;                    j;
;     int  dump_adr;
; 
;     PutString("Dump Memory");
	ldd #L148
	jsr _PutString
monitor2.729::	
; 
;     if (BuildAddress(TRUE) != TERMINATED)
	ldd #1
	jsr _BuildAddress
	cmpb #16
	lbeq L149
monitor2.731::	
;     {
;         adr_ptr = Address;
	movw _Address,-4,x
monitor2.732::	
;         dump_adr = Adrhi * 256 + Adrlo;
	ldab _Adrlo
	clra
	std -16,x
	ldab _Adrhi
	clra
	tba
	clrb
	addd -16,x
	std -10,x
monitor2.733::	
;         CRLF();
	jsr _CRLF
	lbra L152
L151:
monitor2.736::	
;         while ( !done)
;         {
;             for( i = 0; i < ROWSPERSCREEN; i++)
	movb #0,-7,x
	lbra L157
L154:
monitor2.739::	
;             {
;                 /* Start by outputing address to screen */
;                 PutString (" ");
	ldd #L113
	jsr _PutString
monitor2.740::	
;                 PutWord(dump_adr);
	ldd -10,x
	jsr _PutWord
monitor2.741::	
;                 dump_adr += CHARSPERROW;
	ldd -10,x
	addd #16
	std -10,x
monitor2.743::	
;                 /* Adjust pointer for data byte output */
;                 data_ptr = adr_ptr;
	movw -4,x,-6,x
monitor2.744::	
;                 for( j = 0; j < CHARSPERROW; j++)
	movb #0,-1,x
	bra L161
L158:
monitor2.746::	
;                 {
;                     PutString(" ");
	ldd #L113
	jsr _PutString
monitor2.747::	
;                     PutByte(*data_ptr++);
	ldy -6,x
	sty -14,x
	ldd -14,x
	addd #1
	std -6,x
	ldy -14,x
	ldab 0,y
	clra
	jsr _PutByte
monitor2.748::	
;                 }
L159:
	ldab -1,x
	clra
	addd #1
	stab -1,x
L161:
	ldab -1,x
	cmpb #16
	blo L158
monitor2.751::	
;                 /* Row of data bytes have been output *
;                  * a space then the ASCII from memory */
;                 PutString(" ");
	ldd #L113
	jsr _PutString
monitor2.753::	
; 
;                 for( j = 0; j < CHARSPERROW; j++)
	movb #0,-1,x
	bra L165
L162:
monitor2.755::	
;                 {
;                     if ((*adr_ptr >= SPACE) &&
	ldy -4,x
	ldab 0,y
	clra
	std -14,x
	cpd #32
	blt L166
	ldd -14,x
	cpd #126
	bgt L166
monitor2.757::	
;                         (*adr_ptr <= '~'))
;                         PutChar(*adr_ptr);
	ldy -4,x
	ldab 0,y
	tfr b,d
	jsr _PutChar
	bra L167
L166:
monitor2.759::	
;                     else
;                         PutChar('.');
	ldd #46
	jsr _PutChar
L167:
monitor2.760::	
;                     adr_ptr++;
	ldd -4,x
	addd #1
	std -4,x
monitor2.761::	
;                 }
L163:
	ldab -1,x
	clra
	addd #1
	stab -1,x
L165:
	ldab -1,x
	cmpb #16
	blo L162
monitor2.762::	
;                 CRLF();
	jsr _CRLF
monitor2.763::	
;             }
L155:
	ldab -7,x
	clra
	addd #1
	stab -7,x
L157:
	ldab -7,x
	cmpb #24
	lblo L154
monitor2.764::	
;             CRLF();
	jsr _CRLF
monitor2.765::	
;             PutString(" Period/Esc to end.");
	ldd #L168
	jsr _PutString
monitor2.766::	
;             input = GetChar();
	jsr _GetChar
	tfr b,d
	stab -11,x
monitor2.767::	
;             if ((input == ESCAPE) ||
	ldab -11,x
	clra
	std -14,x
	cpd #27
	beq L171
	ldd -14,x
	cpd #46
	bne L169
L171:
monitor2.769::	
;                 (input == PERIOD))
;                 done = TRUE;
	ldab #1
	stab -12,x
	bra L170
L169:
monitor2.771::	
;             else
;                 puts("\n");
	ldd #L172
	jsr _puts
L170:
monitor2.773::	
L152:
monitor2.734::	
	tst -12,x
	lbeq L151
monitor2.774::	
; 
;         }
;     }
L149:
monitor2.775::	
; }
L147:
	tfr x,s
	pulx
	rts
;             in -> 3,x
_Display_New_Addr::
	pshd
	pshx
	tfr s,x
	leas -2,sp
monitor2.785::	
; 
; /********************************************************
;  *                                                      *
;  * Function to add nibble passed to routine as the Least*
;  * significant nibble of address being built            *
;  *                                                      *
;  ********************************************************/
; void Display_New_Addr(char in)
; {
;     Adrhi = (unsigned char)((Adrhi*16) + (Adrlo/16));
	ldy #16
	ldab _Adrlo
	clra
	exg x,y
	idivs
	exg x,y
	sty -2,x
	ldab _Adrhi
	clra
	lsld
	lsld
	lsld
	lsld
	addd -2,x
	stab _Adrhi
monitor2.786::	
;     Adrlo = (unsigned char)((Adrlo*16) + in);
	ldab 3,x
	tfr b,d
	std -2,x
	ldab _Adrlo
	clra
	lsld
	lsld
	lsld
	lsld
	addd -2,x
	stab _Adrlo
monitor2.787::	
;     Back(4);
	ldd #4
	jsr _Back
monitor2.788::	
;     PutByte(Adrhi);
	ldab _Adrhi
	clra
	jsr _PutByte
monitor2.789::	
;     PutByte(Adrlo);
	ldab _Adrlo
	clra
	jsr _PutByte
monitor2.790::	
; }
L173:
	tfr x,s
	pulx
	leas 2,sp
	rts
;             in -> 3,x
_Display_New_Char::
	pshd
	pshx
	tfr s,x
monitor2.800::	
; 
; /*********************************************************
;  *                                                       *
;  * Function to add nibble passed to routine as the Least *
;  * significant nibble of character being built           *
;  *                                                       *
;  *********************************************************/
; void Display_New_Char(char in)
; {
;     Back(2);
	ldd #2
	jsr _Back
monitor2.801::	
;     PutByte(in);
	ldab 3,x
	tfr b,d
	clra
	jsr _PutByte
monitor2.802::	
; }
L174:
	tfr x,s
	pulx
	leas 2,sp
	rts
_GetChar::
monitor2.811::	
; 
; /****************************************************
;  *                                                  *
;  * Function to Get an ASCII character from SCI port *
;  * Returns received character to calling routine.   *
;  *                                                  *
;  ****************************************************/
; char GetChar (void)
; {
L176:
monitor2.812::	
;     while (!(SC0SR1 & RE));   /* Wait for character */
L177:
	brclr 0xc4,#32,L176
monitor2.813::	
;     return (SC0DRL);
	; vol
	ldab 0xc7
	tfr b,d
L175:
	rts
;        outchar -> 3,x
_PutChar::
	pshd
	pshx
	tfr s,x
monitor2.822::	
; }
; 
; /*********************************************************
;  *                                                       *
;  * Function to output ASCII character passed on SCI Port *
;  *                                                       *
;  *********************************************************/
; void PutChar (char outchar)
; {
L180:
monitor2.823::	
;     while (!(SC0SR1 & TRANSCOMPLETE));
L181:
	brclr 0xc4,#64,L180
monitor2.824::	
;     SC0DRL = outchar;
	ldab 3,x
	tfr b,d
	stab 0xc7
monitor2.825::	
; }
L179:
	tfr x,s
	pulx
	leas 2,sp
	rts
;          ?temp -> -2,x
;             in -> 2,x
_PutString::
	pshd
	pshx
	tfr s,x
	leas -2,sp
monitor2.828::	
; 
; void PutString (char *in)
; {
	bra L185
L184:
monitor2.830::	
	movw 2,x,-2,x
	ldd -2,x
	addd #1
	std 2,x
	ldy -2,x
	ldab 0,y
	tfr b,d
	jsr _PutChar
L185:
monitor2.829::	
;     while (*in)
	ldy 2,x
	tst 0,y
	bne L184
monitor2.831::	
;         PutChar (*in++);
; }
L183:
	tfr x,s
	pulx
	leas 2,sp
	rts
_CRLF::
monitor2.840::	
; 
; /*********************************************************
;  *                                                       *
;  * Function to output Carrage return Linefeed to SCI Port*
;  *                                                       *
;  *********************************************************/
; void CRLF(void)
; {
;     PutChar (CR);
	ldd #13
	jsr _PutChar
monitor2.841::	
;     PutChar (LF);
	ldd #10
	jsr _PutChar
monitor2.842::	
; }
L187:
	rts
;          ?temp -> -2,x
;          count -> 3,x
_Back::
	pshd
	pshx
	tfr s,x
	leas -2,sp
monitor2.852::	
; 
; /************************************************
;  *                                              *
;  * Function to erase passed count of characters *
;  * and leave the cursor at the last character   *
;  * that it removes.                             *
;  *                                              *
;  ************************************************/
; void Back (char count)
; {
	bra L190
L189:
monitor2.855::	
	ldd #8
	jsr _PutChar
monitor2.856::	
	ldd #32
	jsr _PutChar
monitor2.857::	
	ldd #8
	jsr _PutChar
monitor2.858::	
L190:
monitor2.853::	
;     while (count--)
	ldab 3,x
	tfr b,d
	std -2,x
	subd #1
	stab 3,x
	ldd -2,x
	bne L189
monitor2.859::	
;     {
;         PutChar(BS);
;         PutChar(SPACE);
;         PutChar(BS);
;     }
; }
L188:
	tfr x,s
	pulx
	leas 2,sp
	rts
;           temp -> -1,x
;        outword -> 2,x
_PutWord::
	pshd
	pshx
	tfr s,x
	leas -2,sp
monitor2.869::	
; 
; /*******************************************************
;  *                                                     *
;  *  Function to output Word passed as 4 Hex digits     *
;  *                                                     *
;  *******************************************************/
; void PutWord (unsigned int outword)
; {
;     unsigned char temp;
;     temp = (outword/256);
	ldd 2,x
	tfr a,b
	clra
	stab -1,x
monitor2.870::	
;     PutByte(temp);
	ldab -1,x
	clra
	jsr _PutByte
monitor2.871::	
;     temp = outword & 0xFF;
	ldd 2,x
	anda #0
	andb #255
	stab -1,x
monitor2.872::	
;     PutByte(temp);
	ldab -1,x
	clra
	jsr _PutByte
monitor2.873::	
; }
L192:
	tfr x,s
	pulx
	leas 2,sp
	rts
;           temp -> -1,x
;        outchar -> 3,x
_PutByte::
	pshd
	pshx
	tfr s,x
	leas -2,sp
	ldd 2,x
	stab 3,x
monitor2.884::	
; 
; /*******************************************************
;  *                                                     *
;  * Function to output Character passed as 2 Hex digits *
;  *                                                     *
;  *******************************************************/
; void PutByte (unsigned char outchar)
; {
;     unsigned char temp;      /* Used for input while manipulating */
; 
;     temp = outchar/16;
	ldy #16
	ldab 3,x
	clra
	exg x,y
	idivs
	exg x,y
	xgdy
	stab -1,x
monitor2.885::	
;     if (temp > 9)
	ldab -1,x
	cmpb #9
	bls L194
monitor2.887::	
;         /* Character is an alpha */
;         temp = temp + 0x37;
	ldab -1,x
	clra
	addd #55
	stab -1,x
	bra L195
L194:
monitor2.889::	
;     else
;         temp = temp + 0x30;
	ldab -1,x
	clra
	addd #48
	stab -1,x
L195:
monitor2.891::	
; 
;     PutChar (temp);         /* Output most significant nibble */
	ldab -1,x
	tfr b,d
	jsr _PutChar
monitor2.893::	
; 
;     temp = outchar &0xF;    /* Strip MS nibble */
	ldab 3,x
	clra
	anda #0
	andb #15
	stab -1,x
monitor2.894::	
;     if (temp > 9)
	ldab -1,x
	cmpb #9
	bls L196
monitor2.895::	
;         temp += 0x37;
	ldab -1,x
	clra
	addd #55
	stab -1,x
	bra L197
L196:
monitor2.897::	
;     else
;         temp += 0x30;
	ldab -1,x
	clra
	addd #48
	stab -1,x
L197:
monitor2.899::	
; 
;     PutChar (temp);  /* Output least significant nibble */
	ldab -1,x
	tfr b,d
	jsr _PutChar
monitor2.900::	
; }
L193:
	tfr x,s
	pulx
	leas 2,sp
	rts
_DisplayCommands::
monitor2.909::	
; 
; /*******************************************************
;  *                                                     *
;  * Function to Display Commands defined for monitor    *
;  *                                                     *
;  *******************************************************/
; void DisplayCommands(void)
; {
;     puts ("\n\n Copyright Jack Crotty all Rights Reserved");
	ldd #L199
	jsr _puts
monitor2.910::	
;     puts (" Commands are:\n");
	ldd #L200
	jsr _puts
monitor2.911::	
;     puts (" d = Dump");
	ldd #L201
	jsr _puts
monitor2.912::	
;     puts (" e = Examine");
	ldd #L202
	jsr _puts
monitor2.913::	
;     puts (" E = Erase Flash");
	ldd #L203
	jsr _puts
monitor2.914::	
;     puts (" f = Fill");
	ldd #L204
	jsr _puts
monitor2.915::	
;     puts (" g = Run Code");
	ldd #L205
	jsr _puts
monitor2.916::	
;     puts (" l = Load RAM");
	ldd #L206
	jsr _puts
monitor2.917::	
;     puts (" p = Load Flash");
	ldd #L207
	jsr _puts
monitor2.918::	
;     puts (" t = Flip LED");
	ldd #L208
	jsr _puts
monitor2.919::	
;     puts (" v = Verify Load");
	ldd #L209
	jsr _puts
monitor2.920::	
;     puts (" ? = Cmds");
	ldd #L210
	jsr _puts
monitor2.921::	
; }
L198:
	rts
;           temp -> -1,x
_Initialize::
	pshx
	tfr s,x
	leas -2,sp
monitor2.932::	
; 
; /*******************************************************
;  *                                                     *
;  * Function to Initialize the state of the processor   *
;  *                                                     *
;  *******************************************************/
; void Initialize(void)
; {
;     char    temp;
; 
;     PEAR    = 4;        /* Enable read/write signal for external RAM     */
	movb #4,0xa
monitor2.933::	
;     MXAR    = 7;        /* Enable Addr 16,17, and 18                     */
	movb #7,0x38
monitor2.934::	
;     CSCTL0  = 0x30;     /* Enable CSD & CSPO                             */
	movb #48,0x3c
monitor2.935::	
;     CSCTL1  = 0x10;     /* Enable lower half of memory map               */
	movb #16,0x3d
monitor2.936::	
;     MODE    = 0xB0;     /* Set for Normal Expanded Narrow (176 = B0 Hex) */
	movb #176,0xb
monitor2.937::	
;     WINDEF  = 0xC0;     /* Enable data and program windows               */
	movb #192,0x37
monitor2.939::	
; 
;     COPCTL  = 0;        /* Turn off COP                                  */
	movb #0,0x16
monitor2.940::	
;     setbaud(BAUD38K);   /* Set baud rate to 38400                        */
	ldd #13
	jsr _setbaud
	bra L213
L212:
monitor2.944::	
	; vol
	ldab 0xc7
	stab -1,x
L213:
monitor2.942::	
; 
;     while ( SC0SR1 & 0x20 )
	brclr 0xc4,#32,X4
	bra L212
X4:
monitor2.946::	
;         /* Read register to clear flag RDRF */
;         temp = SC0DRL;
; 
;     Clr_Screen();
	jsr _Clr_Screen
monitor2.947::	
;     Last_PPAGE = LAST_PPAGE;/* Last PPAGE defaults to 512k can be set by *
	movb #31,_Last_PPAGE
monitor2.949::	
;                              * changing RAM using monitor or recompiling */
;     Banking    = FALSE;     /* S Records will write directly to 8000 - FFFF */
	movb #0,_Banking
monitor2.950::	
;     DDRT       = 208;       /* Make Port T B7 B6 B4 Output */
	movb #208,0xaf
monitor2.951::	
; }
L211:
	tfr x,s
	pulx
	rts
_Clr_Screen::
monitor2.961::	
; 
; /********************************
;  *                              *
;  * Function to Clear the screen *
;  *                              *
;  ********************************/
; 
; void Clr_Screen (void)
; {
;     PutChar (ESCAPE);
	ldd #27
	jsr _PutChar
monitor2.962::	
;     PutString ("[2J");
	ldd #L216
	jsr _PutString
monitor2.963::	
; }
L215:
	rts
L254:
	.word L225
	.word L226
	.word L237
	.word L238
	.word L222
	.word L222
	.word L222
	.word L222
	.word L239
;          ?temp -> -6,x
;          ?temp -> -4,x
;         inchar -> -1,x
_Process_Cmd::
	pshx
	tfr s,x
	leas -6,sp
monitor2.974::	
; 
; /************************************************
;  *                                              *
;  * Function to Process Commands entered by user *
;  *                                              *
;  ************************************************/
; void Process_Cmd (void)
; {
; 	char inchar;
; 
;     DisplayCommands();
	jsr _DisplayCommands
L218:
monitor2.977::	
;     do
; 	{
;         CRLF();
	jsr _CRLF
monitor2.978::	
;         PutString(" Enter Command: ");
	ldd #L221
	jsr _PutString
monitor2.979::	
;         inchar = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.981::	
; 
;         switch (inchar)
	ldab -1,x
	tfr b,d
	std -4,x
	cpd #100
	blt L252
	ldd -4,x
	cpd #108
	bgt L253
	ldd -4,x
	lsld
	addd #L254-200
	xgdy
	jmp [0,y]
L252:
	ldd -4,x
	cpd #63
	lbeq L251
	ldd -4,x
	cpd #63
	lblt L222
L256:
	ldd -4,x
	cpd #69
	beq L227
	lbra L222
L253:
	ldd -4,x
	cpd #112
	lbeq L241
	ldd -4,x
	cpd #112
	lblt L222
L257:
	ldd -4,x
	cpd #116
	lbeq L243
	ldd -4,x
	cpd #118
	lbeq L245
	lbra L222
L225:
monitor2.984::	
; 		{
;             case 'd':
;                 Dump();
	jsr _Dump
monitor2.985::	
;                 break;
	lbra L223
L226:
monitor2.988::	
; 
;             case 'e':
;                 Examine();
	jsr _Examine
monitor2.989::	
;                 break;
	lbra L223
L227:
monitor2.992::	
; 
;             case 'E':
;                 PutString ("Erase Flash Continue?");
	ldd #L228
	jsr _PutString
monitor2.993::	
;                 inchar = GetChar();
	jsr _GetChar
	stab -1,x
monitor2.994::	
;                 Back(9);               /* Erase continue from screen */
	ldd #9
	jsr _Back
monitor2.995::	
;                 if ((inchar == 'y') ||
	ldab -1,x
	tfr b,d
	std -6,x
	cpd #121
	beq L231
	ldd -6,x
	cpd #89
	bne L229
L231:
monitor2.998::	
;                     (inchar == 'Y'))
;                 {
;                     EraseFlash();
	jsr _EraseFlash
monitor2.999::	
;                     if ( Error)
	tst _Error
	beq L232
monitor2.1000::	
;                         PutString("FAILED");
	ldd #L234
	jsr _PutString
	bra L223
L232:
monitor2.1002::	
;                     else
;                         PutString("Passed");
	ldd #L235
	jsr _PutString
monitor2.1003::	
;                 }
	bra L223
L229:
monitor2.1005::	
;                 else
;                     PutString ("Aborted");
	ldd #L236
	jsr _PutString
monitor2.1006::	
;                 break;
	bra L223
L237:
monitor2.1009::	
; 
;             case 'f':
;                 Fill();
	jsr _Fill
monitor2.1010::	
;                 break;
	bra L223
L238:
monitor2.1013::	
; 
;             case 'g':
;                 Execute();
	jsr _Execute
monitor2.1014::	
;                 break;
	bra L223
L239:
monitor2.1017::	
; 
;             case 'l':
;                 PutString("Load RAM");
	ldd #L240
	jsr _PutString
monitor2.1018::	
;                 Error = FALSE;
	movb #0,_Error
monitor2.1019::	
;                 Load_SRecord();
	jsr _Load_SRecord
monitor2.1020::	
;                 LED_Off();
	jsr _LED_Off
monitor2.1021::	
;                 break;
	bra L223
L241:
monitor2.1024::	
; 
;            case 'p':
;                 PutString("Prog Flash");
	ldd #L242
	jsr _PutString
monitor2.1025::	
;                 Program_Flash();
	jsr _Program_Flash
monitor2.1026::	
;                 CRLF();
	jsr _CRLF
monitor2.1027::	
;                 LED_Off();
	jsr _LED_Off
monitor2.1028::	
;                 break;
	bra L223
L243:
monitor2.1031::	
; 
;             case 't':
;                 PutString("LED Toggled");
	ldd #L244
	jsr _PutString
monitor2.1032::	
;                 PORTT = PORTT ^ LED;
	; vol
	ldab 0xae
	clra
	eora #0
	eorb #64
	stab 0xae
monitor2.1033::	
;                 break;
	bra L223
L245:
monitor2.1036::	
; 
;             case 'v':
;                 PutString("Verify Load");
	ldd #L246
	jsr _PutString
monitor2.1037::	
;                 Verify_SRecord();
	jsr _Verify_SRecord
monitor2.1038::	
;                 if (Error)
	tst _Error
	beq L247
monitor2.1040::	
;                 {
;                     PutString(" FAILED");
	ldd #L249
	jsr _PutString
monitor2.1041::	
;                     LED_On();
	jsr _LED_On
monitor2.1042::	
;                 }
	bra L223
L247:
monitor2.1045::	
;                 else
;                 {
;                     PutString(" OK");
	ldd #L250
	jsr _PutString
monitor2.1046::	
;                     LED_Off();
	jsr _LED_Off
monitor2.1048::	
;                 }
;                 break;
	bra L223
L251:
monitor2.1051::	
; 
;             case '?':
;                 Clr_Screen();
	jsr _Clr_Screen
monitor2.1052::	
;                 DisplayCommands();
	jsr _DisplayCommands
monitor2.1053::	
;                 break;
L222:
L223:
monitor2.1055::	
; 		}// end switch
;     } while (inchar != 02);
L219:
	ldab -1,x
	cmpb #2
	lbne L218
monitor2.1056::	
; }
L217:
	tfr x,s
	pulx
	rts
	.area bss
_MSBadr::
	.blkb 1
_Last_PPAGE::
	.blkb 1
_Error::
	.blkb 1
_Data::
	.blkb 1
_Curpage::
	.blkb 1
_Count::
	.blkb 1
_CheckSum::
	.blkb 1
_Banking::
	.blkb 1
_Adrlo::
	.blkb 1
_Adrhi::
	.blkb 1
_Address::
	.blkb 2
	.area text
L250:
	.byte 32,'O,'K,0
L249:
	.byte 32,'F,'A,'I,'L,'E,'D,0
L246:
	.byte 'V,'e,'r,'i,'f,'y,32,'L,'o,'a,'d,0
L244:
	.byte 'L,'E,'D,32,'T,'o,'g,'g,'l,'e,'d,0
L242:
	.byte 'P,'r,'o,'g,32,'F,'l,'a,'s,'h,0
L240:
	.byte 'L,'o,'a,'d,32,'R,'A,'M,0
L236:
	.byte 'A,'b,'o,'r,'t,'e,'d,0
L235:
	.byte 'P,'a,'s,'s,'e,'d,0
L234:
	.byte 'F,'A,'I,'L,'E,'D,0
L228:
	.byte 'E,'r,'a,'s,'e,32,'F,'l,'a,'s,'h,32,'C,'o,'n,'t
	.byte 'i,'n,'u,'e,63,0
L221:
	.byte 32,'E,'n,'t,'e,'r,32,'C,'o,'m,'m,'a,'n,'d,58,32
	.byte 0
L216:
	.byte 91,50,'J,0
L210:
	.byte 32,63,32,61,32,'C,'m,'d,'s,0
L209:
	.byte 32,'v,32,61,32,'V,'e,'r,'i,'f,'y,32,'L,'o,'a,'d
	.byte 0
L208:
	.byte 32,'t,32,61,32,'F,'l,'i,'p,32,'L,'E,'D,0
L207:
	.byte 32,'p,32,61,32,'L,'o,'a,'d,32,'F,'l,'a,'s,'h,0
L206:
	.byte 32,'l,32,61,32,'L,'o,'a,'d,32,'R,'A,'M,0
L205:
	.byte 32,'g,32,61,32,'R,'u,'n,32,'C,'o,'d,'e,0
L204:
	.byte 32,'f,32,61,32,'F,'i,'l,'l,0
L203:
	.byte 32,'E,32,61,32,'E,'r,'a,'s,'e,32,'F,'l,'a,'s,'h
	.byte 0
L202:
	.byte 32,'e,32,61,32,'E,'x,'a,'m,'i,'n,'e,0
L201:
	.byte 32,'d,32,61,32,'D,'u,'m,'p,0
L200:
	.byte 32,'C,'o,'m,'m,'a,'n,'d,'s,32,'a,'r,'e,58,10,0
L199:
	.byte 10,10,32,'C,'o,'p,'y,'r,'i,'g,'h,'t,32,'J,'a,'c
	.byte 'k,32,'C,'r,'o,'t,'t,'y,32,'a,'l,'l,32,'R,'i,'g
	.byte 'h,'t,'s,32,'R,'e,'s,'e,'r,'v,'e,'d,0
L172:
	.byte 10,0
L168:
	.byte 32,'P,'e,'r,'i,'o,'d,47,'E,'s,'c,32,'t,'o,32,'e
	.byte 'n,'d,46,0
L148:
	.byte 'D,'u,'m,'p,32,'M,'e,'m,'o,'r,'y,0
L146:
	.byte 10,32,'E,'n,'d,32,60,32,'S,'t,'a,'r,'t,32,'a,'b
	.byte 'o,'r,'t,'e,'d,33,10,10,0
L145:
	.byte 32,'E,'R,'R,'O,'R,32,'a,'t,58,32,0
L135:
	.byte 32,'E,'n,'t,'e,'r,32,'C,'h,'a,'r,58,32,32,32,32
	.byte 32,0
L130:
	.byte 'F,'i,'l,'l,32,'M,'e,'m,'o,'r,'y,0
L126:
	.byte 32,'R,'u,'n,32,'C,'o,'d,'e,0
L113:
	.byte 32,0
L110:
	.byte 'E,'x,'a,'m,'i,'n,'e,32,'M,'e,'m,'o,'r,'y,0
L73:
	.byte 32,'E,'n,'t,'e,'r,32,'A,'d,'d,'r,'e,'s,'s,58,32
	.byte 32,0
